<template>
  <div class="animation_dialog">
    <el-dialog
      v-model="showLoginDialog"
      :before-close="toggleLoginRegisterDialog"
      destroy-on-close
      width="100%"
      custom-class="animation-dialog"
      style="border-radius: 8px;"
    >
      <template #title>
        <div class="header-title flex font-bold text-white items-center px-2">
          <p class="text-[#C51E2F] font-[900] text-[16px]">
            {{ $t("capital_login") }}
          </p>
        </div>
      </template>
      <div class="mx-auto p-5 p-5 h-full overflow-y-scroll">
        <div class=" ">
          <el-form
            ref="loginFormRef"
            label-position="top"
            :model="loginFormData"
            :rules="loginRules"
            :validate-on-rule-change="false"
            class="w-full mx-auto peru-login-form"
          >
            <div class="flex flex-col h-[calc(100vh-135px)] justify-between">
              <div>
                <el-form-item prop="Username">
                  <template #label>
                    <span class="text-white">{{ $t("username") }}</span>
                  </template>
                  <el-input v-model="loginFormData.Username" type="text" />
                </el-form-item>
                <el-form-item :label="$t('password')" prop="Password">
                  <el-input
                    v-model="loginFormData.Password"
                    show-password
                    type="password"
                  />
                </el-form-item>
                <el-form-item v-if="!clientCaptcha.IsHidden" prop="Captcha" :label="$t('enter_validation_code')">
                  <div class="captcha">
                    <captcha
                      :value="loginFormData.Captcha"
                      @isValid="getCaptchaErrorMsg"
                    />
                    <el-input
                      v-model="loginFormData.Captcha"
                      type="text"
                      class="captcha-input"
                    />
                  </div>
                </el-form-item>
                <!-- <div class="btn-click-captcha-to-verify">
                  <el-form-item prop="Captcha" v-if="!clientCaptcha.IsHidden">
                    <div class="captcha">
                      <captcha :value="loginFormData.Captcha" @isValid="getCaptchaErrorMsg" />
                      <el-input
                        type="text"
                        v-model="loginFormData.Captcha"
                        :placeholder="$t('enter_validation_code')"
                      />
                    </div>
                  </el-form-item>
                </div> -->
              </div>
              <div class="justify-center">
                  <div class="divider"></div>
                  <template class="flex justify-center">
                    <div>
                      <el-button
                        :loading="isLoginProccessing"
                        :type="{ danger: theme !== 'bk8' }"
                        round
                        @click="submitLogin(loginFormRef)"
                        >{{ $t("log_in") }}</el-button
                      >
                    </div>
                  </template>
                  <theme-desktop-peru-components-auth-forgot-password-modal />
                <p
                v-if="!register.IsHidden"
                class="mt-4 mb-[16px] text-center leading-4 font-normal fc-text4 text-[12px]"
              >
                {{ $t("don't_have_an_account?") }}
                <span class="text-primary underline " @click="toggleLoginRegisterDialog(false)" :id="ID.SIGNUP"
                  >{{ $t("joinnow") }}
                </span>
              </p>
                <theme-common-telegram-login-button
                  :is-show="isTelegramBotSetup"
                  :username="telegramBotUsername"
                  @callback="telegramCallbackFunction"
                />
              </div>
            </div>
          </el-form>
        </div>
      </div>
    </el-dialog>
  </div>
</template>

<script lang="ts">
import { computed, defineComponent } from "vue";
import useLogin from "@/composables/useLogin";
import { store } from "@/store";

export default defineComponent({
  name: "Login",
  setup() {
    const { toggleLoginRegisterDialog } = commonHelper;
    const showLoginDialog = computed(() => store.state.showLoginDialog);
    const {
      loginFormRef,
      loginFormData,
      loginRules,
      submitLogin,
      isLoginProccessing,
      register,
      clientCaptcha,
      getCaptchaErrorMsg,
      isTelegramBotSetup,
      telegramBotUsername,
      checkLoginTelegramSetup,
      telegramCallbackFunction,
    } = useLogin();
    const { themeColor } = themePropertyHelper;
    const theme = themeColor.value.Text;
    checkLoginTelegramSetup();
    return {
      loginFormRef,
      loginFormData,
      loginRules,
      submitLogin,
      isLoginProccessing,
      showLoginDialog,
      register,
      theme,
      clientCaptcha,
      getCaptchaErrorMsg,
      toggleLoginRegisterDialog,
      isTelegramBotSetup,
      telegramBotUsername,
      telegramCallbackFunction,
    };
  },
});
</script>
<style scoped>
:deep(.el-dialog) {
  --el-dialog-bg-color: var(--background5);
}
:deep(.el-dialog__headerbtn .el-dialog__close) {
  color: var(--text5);
}
:deep(.el-dialog__header) {
  padding: 16px;
  background: rgba(0, 0, 0, 0.2);
  margin-right: 0px;
  margin-top: 32px;
  border-bottom: 2px solid var(--border);
}
:deep(.el-dialog__body) {
  background: var(--background5);
}
.text-primary {
  color: var(--primary);
}
:deep(button.el-button) {
  width: 328px;
  height: 32px;
  background-color: var(--secondary);
  border: none;
  border-radius: 4px;
}
:deep(.el-input__inner) {
  height: 40px;
  border-radius: 4px;
  background: rgba(0, 0, 0, 0.1);
}
:deep(.el-button span) {
  @apply text-sm font-bold leading-4 text-[color:var(--textBtn)];
}
.divider {
  height: 2px;
  background-color: var(--border);
  margin-bottom: 1rem;
}
.peru-login-form :deep(.el-form-item) {
  margin-bottom: 16px;
}
.captcha {
  width: 100%;
  display: flex;
  gap: 0.5rem;
}
.vue_client_recaptcha {
  height: 32px;
  min-width: 128px;
}
:deep(.vue_client_recaptcha_icon) {
  height: 32px;
  width: fit-content;
  order: 2;
}
:deep(.vue_client_recaptcha_icon img) {
  width: 32px !important;
  height: 32px !important;
}
:deep(.vue_client_recaptcha .captcha_canvas) {
  width: 96px;
  height: 32px;
  order: 1;
  padding: 0;
}
:deep(.captcha-input .el-input__inner) {
  height: 32px !important;
}
:deep(.el-form-item:not(.is-error) .el-input__inner:hover), :deep(.el-form-item:not(.is-error) .el-select:hover .el-input__inner) {
  outline: 0;
  box-shadow: 0 0 0 1px var(--border) inset !important;
}
:deep(.el-form-item:not(.is-error) .el-input__inner:focus), :deep(.el-form-item:not(.is-error) .el-select .el-input.is-focus .el-input__inner) {
  outline: 0;
  box-shadow: 0 0 0 1px var(--selected) inset !important;
}
</style>
<style lang="scss">
.animation-dialog {
  .el-dialog__headerbtn {
    top: 3px;
    .el-icon {
      width: auto;
      height: auto;
      border-radius: 50%;
      background-color: var(--primary);
      svg {
        width: 20px;
        height: 20px;
        color: black;
        padding: 2px;
      }
    }
  }
}
</style>
